int channel;

bool openCommand;
bool validCommand;
bool BNCControl;

String serialData;

const int channel1 = 2;
const int channel2 = 3;
const int channel3 = 4;
const int channel4 = 5;
const int BNC1 = A0;
const int BNC2 = A1;
const int BNC3 = A2;
const int BNC4 = A3;
const int BNCSwitch = A4;

void setup() 
{
  pinMode(channel1, OUTPUT);
  digitalWrite(channel1, LOW);
  pinMode(channel2, OUTPUT);
  digitalWrite(channel2, LOW);
  pinMode(channel3, OUTPUT);
  digitalWrite(channel3, LOW);
  pinMode(channel4, OUTPUT);
  digitalWrite(channel4, LOW);
  
  pinMode(BNCSwitch, INPUT);
  pinMode(BNC1, INPUT);
  pinMode(BNC2, INPUT);
  pinMode(BNC3, INPUT);
  pinMode(BNC4, INPUT);

  Serial.begin(115200);

  Serial.setTimeout(20);
}

void CloseAllChannels()
{
  digitalWrite(channel1, LOW);
  digitalWrite(channel2, LOW);
  digitalWrite(channel3, LOW);
  digitalWrite(channel4, LOW);
}

void loop() 
{
  if (digitalRead(BNCSwitch))
  {
    if (!BNCControl) CloseAllChannels();
    BNCControl = true;
  }
  else
  {
    if (BNCControl) CloseAllChannels();
    BNCControl = false;
  }
  
  if (Serial.available() && !BNCControl)
  {
     ReadSerialData();
     
     if (serialData.indexOf("Connect") != -1) validCommand = true;
    
     while(serialData.indexOf('$') != -1 && serialData.indexOf('#') != -1)
      {
        Decode();
        ExecuteCommand();      
      }       
     
     Answer();
     serialData = "";     
  }

   if (BNCControl) {
    if (digitalRead(BNC1)) {
      digitalWrite(channel1, HIGH);
    }
    else digitalWrite(channel1, LOW);
    
    if (digitalRead(BNC2)) {
      digitalWrite(channel2, HIGH);
    }
    else digitalWrite(channel2, LOW);
    
    if (digitalRead(BNC3)) {
      digitalWrite(channel3, HIGH);
    }
    else digitalWrite(channel3, LOW);
    
    if (digitalRead(BNC4)) {
      digitalWrite(channel4, HIGH);
    }
    else digitalWrite(channel4, LOW);
   }
}
    
void Decode()
{  
  RemoveGarbage();
  if (serialData.indexOf('$') != -1)
  {
    channel = (serialData.substring(serialData.indexOf('$')+1,serialData.indexOf('$')+2 )).toInt(); // sets channel
  
    if ((serialData.substring(serialData.indexOf('/')+1, serialData.indexOf('/') + 2)).toInt() == 1) // sets onOff
    {
      openCommand = true;
    }
    else
    {
      openCommand = false;
    }
    RemoveReadData();
  }
}

void ReadSerialData()
{
  serialData = Serial.readStringUntil('%');
}

void Answer()
{
  if (validCommand)
  {   
    Serial.println("Valid");
  }
  else
  {
    Serial.println("Invalid");
  }
  validCommand = false;
}

void ExecuteCommand()
{
  if (channel != 0) {
    if (openCommand) digitalWrite(channel+1, HIGH);
    else digitalWrite(channel+1, LOW);  
  }

  channel = 0;
  openCommand = false;
}

void RemoveGarbage()
{
  while(true)
  {
    serialData.remove(0,serialData.indexOf('$'));
    if (serialData.indexOf('#') == -1) break; // string does not contain data
    if(serialData[2] == '/' && serialData[4] == '#')
    {
      if((((int)serialData[1] - 48) <= 4 && (serialData[1] - 48) >= 0) && (serialData[3] == '0' || serialData[3] == '1' ))
      {
        validCommand = true;
        break;   // done removing
      }
    }
    serialData.remove(0,serialData.indexOf('$')+1);
  }  
}

void RemoveReadData()
{
  serialData.remove(0,serialData.indexOf('#')+1);
}
